import { INestApplication, ValidationPipe } from '@nestjs/common';
import { Test, TestingModule } from '@nestjs/testing';
import { {{Name}}sService } from '../../{{inputName}}s.service';
import request from 'supertest';
// import mocked{{Name}} from './mocks/{{inputName}}.mock';
import mocked{{Name}}s from './mocks/{{inputName}}s.mock.json';
import { {{Name}}Interface } from 'src-server/{{inputName}}s/models/interfaces/{{inputName}}.interface';
import { Create{{Name}}Dto } from 'src-server/{{inputName}}s/dto';
import { Update{{Name}}Dto } from 'src-server/{{inputName}}s/dto';

describe('{{Name}}s controller', () => {
  let app: INestApplication;
  let {{name}}sService: {{Name}}sService;
  // let expectedData: Partial<{{Name}}Interface>;
  // let mockedGetThirdData: jest.Mock;

  beforeAll(async () => {
    /*
    const mockedThirdService = {
      getThirdData: jest.fn().mockResolvedValue(mocked{{Name}}s),
      // getThirdData: jest.fn().mockReturnValue(Promise.resolve(mocked{{Name}}s)),
      // getThirdData: jest.fn().mockReturnValue(Promise.reject(mocked{{Name}}s)),
      // getThirdData: mockedGetThirdData
    }
    */

    const moduleFixture: TestingModule = await Test.createTestingModule({
      imports: [
        // CoreModule,
        // ThirdModule,
      ],
      providers: [
        {{Name}}sService,
        /*
        {
            provide: ThirdService,
            useValue: mockedThirdService
        },
        */
      ],
    })
      //.overrideProvider(ThirdService)
      //.useValue(mockedThirdService)
      .compile();

    app = await moduleFixture.createNestApplication();
    // AAdd the ValidationPipe if you want to verify your validation.
    app.useGlobalPipes(new ValidationPipe());
    await app.init();

    {{name}}sService = await moduleFixture.get<{{Name}}sService>({{Name}}sService);
  });

  afterEach(() => {
    // To mockRestore the spy
    // You can use mockImplementationOnce() instead of mockImplementation to not having to mockRestore the spy.
    jest.restoreAllMocks();
  });

  // QUERY
  describe('when running a query request', () => {
    describe('and using valid data', () => {
      const expectedData = mocked{{Name}}s;
      const mock{{Name}}sService = jest
        .spyOn({{name}}sService, 'findAll')
        .mockImplementationOnce(() => Promise.resolve(expectedData));
      // mockedGetThirdData = jest.fn().mockResolvedValue(expectedData);
      it('should respond with a list of data', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        return request(app.getHttpServer())
          .get('/{{name}}s')
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(200);
            expect(res.type).toEqual('application/json');
            // Check body data
            expect(res.body).not.toBeNull();
            //expect(res.body).toEqual(expect.any(Object));
            expect(res.body).toEqual(expect.any(Array));
            expect(res.body).toHaveLength(3);
            expect(res.body).toBe(expectedData);
            // Check also first data
            const first{{Name}} = res.body.find(
              ({{name}}: any) => {{name}}.email === 'user@email.com',
            );
            expect(first{{Name}}).toBeTruthy();
            expect(first{{Name}}).toHaveProperty('firstName');
            expect(first{{Name}}.firstName).toBe('John');
            expect(first{{Name}}).toHaveProperty('lastName');
            expect(first{{Name}}.lastName).toBe('Wayne');
            done();
          });
      });
      it('should respond with a list of filtered data', (done) => {
        // Jest will wait until the done callback is called before finishing the test

        return request(app.getHttpServer())
          .get('/{{name}}s?limit=2')
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(200);
            // expect(res.type).toEqual('application/json');
            expect(res.body).not.toBeNull();
            // expect(res.body).toEqual(expect.any(Object));
            expect(res.body).toEqual(expect.any(Array));
            expect(res.body).toHaveLength(2);
            expect(res.body).toBe(expectedData);
            done();
          });
      });
    });
    describe('and using invalid data', () => {
      it('should throw an error', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        const expectedError = { message: 'Error' };
        const mock{{Name}}sService = jest
          .spyOn({{name}}sService, 'findAll')
          .mockImplementationOnce(() => Promise.reject(expectedError));
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedError);

        return request(app.getHttpServer())
          .get('/{{name}}s')
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(500);
            // expect(res.type).toEqual('application/json');
            done();
          });
      });
    });
  });

  // CREATE
  describe('when running a create request', () => {
    describe('and using valid data', () => {
      const inputData: Create{{Name}}Dto = {
        email: 'user4@email.com',
        firstName: 'Jule',
        lastName: 'Wayne',
        phone: '+48123123124',
        description: 'Lorem ipsum 4',
      };

      const expectedData: Partial<{{Name}}Interface> = {
        id: '608ab7e27a84420dfc16b334', // Add a mocked ID
        ...inputData,
      };
      const mock{{Name}}sService = jest
        .spyOn({{name}}sService, 'create')
        .mockImplementationOnce(() =>
          Promise.resolve(expectedData as {{Name}}Interface),
        );
      // mockedGetThirdData = jest.fn().mockResolvedValue(expectedData);

      it('should respond with the added data', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        return request(app.getHttpServer())
          .post('/{{name}}s') // .set({ Authorization: `Basic ${credentialInput}` })
          .send(inputData)
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(201);
            expect(res.type).toEqual('application/json');
            // Check body data
            expect(res.body).not.toBeNull();
            expect(res.body).toEqual(expect.any(Object));
            expect(res.body).toBe(expectedData);
            // Check also {{name}} data
            // expect(res.body).toBeTruthy();
            expect(res.body).toHaveProperty('firstName');
            expect(res.body.firstName).toBe('Jule');
            expect(res.body).toHaveProperty('lastName');
            expect(res.body.lastName).toBe('Wayne');
            done();
          });
      });
    });
    describe('and using invalid data', () => {
      it('should throw an error', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        const inputInvalidData: Partial<Create{{Name}}Dto> = {
          email: '',
        };
        const expectedError = { message: 'Error' };
        const mock{{Name}}sService = jest
          .spyOn({{name}}sService, 'create')
          .mockImplementationOnce(() => Promise.reject(expectedError));
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedError);

        return request(app.getHttpServer())
          .post('/{{name}}s') // .set({ Authorization: `Basic ${credentialInput}` })
          .send(inputInvalidData)
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(500);
            // expect(res.type).toEqual('application/json');
            done();
          });
      });
    });
  });

  // READ
  describe('when running a read request', () => {
    describe('and using valid data', () => {
      const expectedData: Partial<{{Name}}Interface> = {
        id: '608ab7e27a84420dfc16b334',
        email: 'user4@email.com',
        firstName: 'Jule',
        lastName: 'Wayne',
        phone: '+48123123124',
        description: 'Lorem ipsum 4',
      };
      const mock{{Name}}sService = jest
        .spyOn({{name}}sService, 'findOne')
        .mockImplementationOnce(() =>
          Promise.resolve(expectedData as {{Name}}Interface),
        );
      // mockedGetThirdData = jest.fn().mockResolvedValue(expectedData);
      it('should respond with the selected data', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        return request(app.getHttpServer())
          .get(`{{name}}s/${expectedData.id}`)
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(200);
            expect(res.type).toEqual('application/json');
            // Check body data
            expect(res.body).not.toBeNull();
            expect(res.body).toEqual(expect.any(Object));
            expect(res.body).toBe(expectedData);
            // Check also {{name}} data
            // expect(res.body).toBeTruthy();
            expect(res.body).toHaveProperty('firstName');
            expect(res.body.firstName).toBe('Jule');
            expect(res.body).toHaveProperty('lastName');
            expect(res.body.lastName).toBe('Wayne');
            done();
          });
      });
    });
    describe('and using invalid data', () => {
      it('should throw an error', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        const inputInvalidData: Partial<{{Name}}Interface> = {
          id: '0000',
        };
        const expectedError = { message: 'Error' };
        const mock{{Name}}sService = jest
          .spyOn({{name}}sService, 'findOne')
          .mockImplementationOnce(() => Promise.reject(expectedError));
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedError);

        return request(app.getHttpServer())
          .get(`{{name}}s/${inputInvalidData.id}`) // .set({ Authorization: `Basic ${credentialInput}` })
          .send(inputInvalidData)
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(404);
            // expect(res.type).toEqual('application/json');
            done();
          });
      });
    });
  });

  // UPDATE
  describe('when running an update request', () => {
    describe('and using valid data', () => {
      const inputData: Partial<Update{{Name}}Dto> = {
        firstName: 'new name',
      };

      const expectedData: Partial<{{Name}}Interface> = {
        id: '608ab7e27a84420dfc16b334',
        email: 'user4@email.com',
        firstName: inputData.firstName,
        lastName: 'Wayne',
        phone: '+48123123124',
        description: 'Lorem ipsum 4',
      };

      const mock{{Name}}sService = jest
        .spyOn({{name}}sService, 'update')
        .mockImplementationOnce(() =>
          Promise.resolve(expectedData as {{Name}}Interface),
        );
      // mockedGetThirdData = jest.fn().mockResolvedValue(expectedData);

      it('should respond with the updated data', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        return request(app.getHttpServer())
          .put('/{{name}}s') // .set({ Authorization: `Basic ${credentialInput}` })
          .send(inputData)
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(202);
            expect(res.type).toEqual('application/json');
            // Check body data
            expect(res.body).not.toBeNull();
            expect(res.body).toEqual(expect.any(Object));
            expect(res.body).toBe(expectedData);
            // Check also {{name}} data
            // expect(res.body).toBeTruthy();
            expect(res.body).toHaveProperty('firstName');
            expect(res.body.firstName).toBe(inputData.firstName);
            expect(res.body).toHaveProperty('lastName');
            expect(res.body.lastName).toBe('Wayne');
            done();
          });
      });
    });
    describe('and using invalid data', () => {
      it('should throw an error', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        const inputInvalidData: Partial<Create{{Name}}Dto> = {
          firstName: '',
        };
        const expectedError = { message: 'Error' };
        const mock{{Name}}sService = jest
          .spyOn({{name}}sService, 'create')
          .mockImplementationOnce(() => Promise.reject(expectedError));
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedError);

        return request(app.getHttpServer())
          .put('/{{name}}s') // .set({ Authorization: `Basic ${credentialInput}` })
          .send(inputInvalidData)
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(500);
            // expect(res.type).toEqual('application/json');
            done();
          });
      });
    });
  });

  // DELETE
  describe('when running a delete request', () => {
    describe('and using valid data', () => {
      const expectedData: Partial<{{Name}}Interface> = {
        id: '608ab7e27a84420dfc16b334',
        email: 'user4@email.com',
        firstName: 'Jule',
        lastName: 'Wayne',
        phone: '+48123123124',
        description: 'Lorem ipsum 4',
      };
      const mock{{Name}}sService = jest
        .spyOn({{name}}sService, 'remove')
        .mockImplementationOnce(() =>
          Promise.resolve(expectedData as {{Name}}Interface),
        );
      // mockedGetThirdData = jest.fn().mockResolvedValue(expectedData);

      it('should respond with the selected data', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        return request(app.getHttpServer())
          .delete(`{{name}}s/${expectedData.id}`) // .set({ Authorization: `Basic ${credentialInput}` })
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(204);
            expect(res.type).toEqual('application/json');
            // Check body data
            expect(res.body).not.toBeNull();
            expect(res.body).toEqual(expect.any(Object));
            expect(res.body).toBe(expectedData);
            // Check also {{name}} data
            // expect(res.body).toBeTruthy();
            expect(res.body).toHaveProperty('firstName');
            expect(res.body.firstName).toBe('Jule');
            expect(res.body).toHaveProperty('lastName');
            expect(res.body.lastName).toBe('Wayne');
            done();
          });
      });
    });
    describe('and using invalid data', () => {
      it('should throw an error', (done) => {
        // Jest will wait until the done callback is called before finishing the test
        const inputInvalidData: Partial<{{Name}}Interface> = {
          id: '0000',
        };
        const expectedError = { message: 'Error' };
        const mock{{Name}}sService = jest
          .spyOn({{name}}sService, 'remove')
          .mockImplementationOnce(() => Promise.reject(expectedError));
        // mockedGetThirdData = jest.fn().mockResolvedValue(expectedError);

        return request(app.getHttpServer())
          .delete(`{{name}}s/${inputInvalidData.id}`) // .set({ Authorization: `Basic ${credentialInput}` })
          .end((err, res) => {
            if (err) done(err);
            expect(mock{{Name}}sService).toBeDefined();
            expect(mock{{Name}}sService).toHaveBeenCalled();
            expect(res.status).toBe(404);
            // expect(res.type).toEqual('application/json');
            done();
          });
      });
    });
  });
});
